

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>


#include "../s_tools/smem.h"
#include "../s_tools/sfile.h"

/* #include "../as/asfrontend.h" */


main(argc,argv)
int argc;
char **argv;
{
 struct AsfrontenD *frontend= NULL;
 int portnumber= 0,ret, helpmode= 0;
 char username[1024],*servername;
 char *helptext= NULL;
 int Asfrontend_print_interpreter();

 static int blocking_mode= 1;


 /* full memory supervision */
 Smem_set_record_items(1); 

 
 /* ( check arguments ) */
 if(argc < 3) {
   if(argc == 2)
     if(strcmp(argv[1],"-help")==0)
       helpmode= 1; 
   if(!helpmode)
     fprintf(stderr,"usage: %s hostname portnumber [username]\n",argv[0]);
   ret= Asfrontend__helptext(&helptext,0);
   if(ret>0)
     fprintf(stdout,"%s",helptext);
   exit(1);
 } else if (argc==3) {
   username[0]= 0;
 } else {
   if(strlen(argv[3])<sizeof(username)-1) {
     strcpy(username,argv[3]);
   } else {
     fprintf(stderr,"%s : username too long : '%'\n",argv[3]);
     exit(1);
   }
 }
 servername= argv[1];
 sscanf(argv[2],"%ld",&portnumber);
 if(portnumber<=0) {
   fprintf(stderr,"%s : no usable portnumber '%'\n",argv[2]);
     exit(1);
 }


 /* get a frontend object */
 /* It is its own master application and uses Asfrontend_print_interpreter()
    as interpreter for incoming replies */
 ret= Asfrontend_new(&frontend,NULL,Asfrontend_print_interpreter,
                    servername,portnumber,username,0);
 if(ret<=0) {
creation_failed:;
   fprintf(stderr,"%s : creation of frontend object failed\n",argv[0]);
   exit(2);
 }

 /* Not needed here, but necessary in more flexible I/O environments:
    How to obtain the filedescriptor for possible usage with select() */
 fprintf(stderr,"connected to %s %ld via filedescriptor   %ld\n",
                servername,portnumber,
                Asfrontend_get_fd(frontend,0));


 /* Send initial commands to establish a backchannel at the server.
    This function subscribes to all types of notification messages */
 ret= Asfrontend_send_initial(frontend,1);
 if(ret<=0) {
   fprintf(stderr,"%s : sending of initial commands failed.\n",argv[0]);
   exit(3);
 }

 /* This example uses the synchronous input loop */
 /* for asynchronous i/o see Asfrontend_callback() */
 ret= Asfrontend_input_loop(frontend,0);
 if(ret<0) 
   exit(-ret);

 /* close connection to server */
 Asfrontend_destroy(&frontend,0);


 /* final memory clearance check */
 Smem_stderr(1|2);


 exit(0);
}


