
/*
  cc -g -o httpdoc.c
*/
/* ( generated by CgeN on  Wed, 08 Aug 2001 19:08:40 GMT ) */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include "../s_tools/smem.h"
#include "../s_tools/sfile.h"
#include "../s_tools/sregex.h"

#include "httpdoc.h"


/* --------------------------  HttpdoC  ----------------------- */


int Httpdoc_new(objpt,flag)
struct HttpdoC **objpt;
int flag;
{
 struct HttpdoC *o;
 int ret,i;

 *objpt= o= TSOB_FELD(struct HttpdoC,1);
 if(o==NULL)
   return(-1);

 o->uri= NULL;
 o->fileadress= NULL;
 o->headers= NULL;
 o->last_header= NULL;
 o->forms= NULL;
 o->last_form= NULL;
 o->links= NULL;
 o->last_link= NULL;
 o->images= NULL;
 o->last_image= NULL;
 o->up= NULL;
 o->down= NULL;
 o->prev= NULL;
 o->next= NULL;

 return(1);
failed:;
 Httpdoc_destroy(objpt,0);
 return(-1);
}


int Httpdoc_new_headers(o,flag)
struct HttpdoC *o;
int flag;
{
 int ret;
 struct HttpheadeR *c= NULL;

 ret= Httpheader_new(&c,0);
 if(ret<=0)
   return(ret);
 Httpheader_link(c,o->last_header,0);
 o->last_header= c;
 if(o->headers==NULL)
   o->headers= c;
 return(1);
}


int Httpdoc_new_forms(o,flag)
struct HttpdoC *o;
int flag;
{
 int ret;
 struct HttpforM *c= NULL;

 ret= Httpform_new(&c,0);
 if(ret<=0)
   return(ret);
 Httpform_link(c,o->last_form,0);
 o->last_form= c;
 if(o->forms==NULL)
   o->forms= c;
 return(1);
}


int Httpdoc_new_links(o,flag)
struct HttpdoC *o;
int flag;
{
 int ret;
 struct HttplinK *c= NULL;

 ret= Httplink_new(&c,0);
 if(ret<=0)
   return(ret);
 Httplink_link(c,o->last_link,0);
 o->last_link= c;
 if(o->links==NULL)
   o->links= c;
 return(1);
}


int Httpdoc_new_images(o,flag)
struct HttpdoC *o;
int flag;
{
 int ret;
 struct HttpimagE *c= NULL;

 ret= Httpimage_new(&c,0);
 if(ret<=0)
   return(ret);
 Httpimage_link(c,o->last_image,0);
 o->last_image= c;
 if(o->images==NULL)
   o->images= c;
 return(1);
}


int Httpdoc_destroy(objpt,flag)
struct HttpdoC **objpt;
int flag;
{
 struct HttpdoC *o;

 o= *objpt;
 if(o==NULL)
   return(0);

 Sregex_string(&(o->uri),NULL,0);
 Sregex_string(&(o->fileadress),NULL,0);
 Httpheader_destroy_all(&(o->headers),0);
 Httpform_destroy_all(&(o->forms),0);
 Httplink_destroy_all(&(o->links),0);
 Httpimage_destroy_all(&(o->images),0);
 if(o->up!=NULL)
   o->up->down= o->down;
 if(o->down!=NULL)
   o->down->up= o->up;
 if(o->prev!=NULL)
   o->prev->next= o->next;
 if(o->next!=NULL)
   o->next->prev= o->prev;

 Smem_freE((char *) o);
 *objpt= NULL;
 return(1);
}


int Httpdoc_destroy_all(objpt,flag)
struct HttpdoC **objpt;
int flag;
{
 struct HttpdoC *o,*n;

 o= *objpt;
 if(o==NULL)
   return(0);
 for(;o->prev!=NULL;o= o->prev);
 for(;o!=NULL;o= n) {
   n= o->next;
   Httpdoc_destroy(&o,0);
 }
 *objpt= NULL;
 return(1);
}


int Httpdoc_get_uri(o,pt,flag)
struct HttpdoC *o;
char **pt;
int flag;
{
 *pt= o->uri;
 return(1);
}


int Httpdoc_get_fileadress(o,pt,flag)
struct HttpdoC *o;
char **pt;
int flag;
{
 *pt= o->fileadress;
 return(1);
}


int Httpdoc_get_headers(o,pt,flag)
struct HttpdoC *o;
struct HttpheadeR **pt;
int flag;
{
 *pt= o->headers;
 return(1);
}


int Httpdoc_get_last_header(o,pt,flag)
struct HttpdoC *o;
struct HttpheadeR **pt;
int flag;
{
 *pt= o->last_header;
 return(1);
}


int Httpdoc_get_forms(o,pt,flag)
struct HttpdoC *o;
struct HttpforM **pt;
int flag;
{
 *pt= o->forms;
 return(1);
}


int Httpdoc_get_last_form(o,pt,flag)
struct HttpdoC *o;
struct HttpforM **pt;
int flag;
{
 *pt= o->last_form;
 return(1);
}


int Httpdoc_get_links(o,pt,flag)
struct HttpdoC *o;
struct HttplinK **pt;
int flag;
{
 *pt= o->links;
 return(1);
}


int Httpdoc_get_last_link(o,pt,flag)
struct HttpdoC *o;
struct HttplinK **pt;
int flag;
{
 *pt= o->last_link;
 return(1);
}


int Httpdoc_get_images(o,pt,flag)
struct HttpdoC *o;
struct HttpimagE **pt;
int flag;
{
 *pt= o->images;
 return(1);
}


int Httpdoc_get_last_image(o,pt,flag)
struct HttpdoC *o;
struct HttpimagE **pt;
int flag;
{
 *pt= o->last_image;
 return(1);
}


int Httpdoc_get_up(o,pt,flag)
struct HttpdoC *o;
struct HttpdoC **pt;
int flag;
{
 *pt= o->up;
 return(1);
}


int Httpdoc_get_down(o,pt,flag)
struct HttpdoC *o;
struct HttpdoC **pt;
int flag;
{
 *pt= o->down;
 return(1);
}


int Httpdoc_get_prev(o,pt,flag)
struct HttpdoC *o;
struct HttpdoC **pt;
int flag;
{
 *pt= o->prev;
 return(1);
}


int Httpdoc_get_next(o,pt,flag)
struct HttpdoC *o;
struct HttpdoC **pt;
int flag;
{
 *pt= o->next;
 return(1);
}


int Httpdoc_link(o,link,flag)
struct HttpdoC *o;
struct HttpdoC *link;
int flag;
/*
  bit0= insert as link->prev rather than as link->next
*/
{
 if(o->prev!=NULL)
   o->prev->next= o->next;
 if(o->next!=NULL)
   o->next->prev= o->prev;
 o->prev= o->next= NULL;
 if(link==NULL)
   return(1);
 if(flag&1) {
   o->next= link;
   o->prev= link->prev;
   if(o->prev!=NULL)
     o->prev->next= o;
   link->prev= o;
 } else {
   o->prev= link;
   o->next= link->next;
   if(o->next!=NULL)
     o->next->prev= o;
   link->next= o;
 }
 return(1);
}

