
/*
  cc -g -o httpfield.c
*/
/* ( generated by CgeN on  Wed, 08 Aug 2001 19:08:40 GMT ) */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include "../s_tools/smem.h"
#include "../s_tools/sfile.h"
#include "../s_tools/sregex.h"

#include "httpfield.h"


/* --------------------------  HttpfielD  ----------------------- */


int Httpfield_new(objpt,flag)
struct HttpfielD **objpt;
int flag;
{
 struct HttpfielD *o;
 int ret,i;

 *objpt= o= TSOB_FELD(struct HttpfielD,1);
 if(o==NULL)
   return(-1);

 o->name= NULL;
 o->content= NULL;
 o->content_len= 0;
 o->state= 0;
 o->content_disp= NULL;
 o->prev= NULL;
 o->next= NULL;

 return(1);
failed:;
 Httpfield_destroy(objpt,0);
 return(-1);
}


int Httpfield_destroy(objpt,flag)
struct HttpfielD **objpt;
int flag;
{
 struct HttpfielD *o;

 o= *objpt;
 if(o==NULL)
   return(0);

 Sregex_string(&(o->name),NULL,0);
 Sregex_string(&(o->content),NULL,0);
 Sregex_string(&(o->content_disp),NULL,0);
 if(o->prev!=NULL)
   o->prev->next= o->next;
 if(o->next!=NULL)
   o->next->prev= o->prev;

 Smem_freE((char *) o);
 *objpt= NULL;
 return(1);
}


int Httpfield_destroy_all(objpt,flag)
struct HttpfielD **objpt;
int flag;
{
 struct HttpfielD *o,*n;

 o= *objpt;
 if(o==NULL)
   return(0);
 for(;o->prev!=NULL;o= o->prev);
 for(;o!=NULL;o= n) {
   n= o->next;
   Httpfield_destroy(&o,0);
 }
 *objpt= NULL;
 return(1);
}


int Httpfield_get_name(o,pt,flag)
struct HttpfielD *o;
char **pt;
int flag;
{
 *pt= o->name;
 return(1);
}


int Httpfield_get_content(o,pt,flag)
struct HttpfielD *o;
char **pt;
int flag;
{
 *pt= o->content;
 return(1);
}


int Httpfield_get_prev(o,pt,flag)
struct HttpfielD *o;
struct HttpfielD **pt;
int flag;
{
 *pt= o->prev;
 return(1);
}


int Httpfield_get_next(o,pt,flag)
struct HttpfielD *o;
struct HttpfielD **pt;
int flag;
{
 *pt= o->next;
 return(1);
}


int Httpfield_link(o,link,flag)
struct HttpfielD *o;
struct HttpfielD *link;
int flag;
/*
  bit0= insert as link->prev rather than as link->next
*/
{
 if(o->prev!=NULL)
   o->prev->next= o->next;
 if(o->next!=NULL)
   o->next->prev= o->prev;
 o->prev= o->next= NULL;
 if(link==NULL)
   return(1);
 if(flag&1) {
   o->next= link;
   o->prev= link->prev;
   if(o->prev!=NULL)
     o->prev->next= o;
   link->prev= o;
 } else {
   o->prev= link;
   o->next= link->next;
   if(o->next!=NULL)
     o->next->prev= o;
   link->next= o;
 }
 return(1);
}


int Httpfield_read_multipart(o,req,data,datalen,read_pt,flag)
struct HttpfielD *o;
struct HttprequesT *req;
char *data;
int datalen;
char **read_pt;
int flag;
{
 int ret;
 int i,l,rptlen,false_len;
 char *boundary,*rpt,*lfpt,*npt,*ept;

 rpt= data;
 rptlen= datalen;

read_text:;
 if(o->state==0) {
   lfpt= NULL;
   if(rptlen<=0)
     return(2);
   for(i=0;i<rptlen;i++)
     if(rpt[i]=='\n') {
       lfpt= rpt+i;
   break;
     }
   if(lfpt!=NULL) {
     if(Sregex_string_cut(&(o->content_disp),rpt,(lfpt-rpt)+1,1)<=0)
       return(-1);
     *read_pt= lfpt+1;
       l= strlen(o->content_disp);
     if(l>=2)
       if(o->content_disp[l-2]=='\r') {
         o->content_disp[l-2]= 0;
         if(strncmp(o->content_disp,"Content-disposition: ",
                    strlen("Content-disposition: "))==0) {
           /* obtain name */;
           npt= strstr(o->content_disp,"name=\"");
           if(npt==NULL)
             goto read_more;
           ept= strchr(npt+7,'"');
           if(ept==NULL)
             goto read_more;
           if(Sregex_string_cut(&(o->name),npt+7,ept-(npt+7),0)<=0)
             {ret= -1; goto ex;}
           o->state= 1;
           goto read_more;
         } else if (o->content_disp==NULL) {
           o->state= 2;
           goto read_more;
         } else if (o->content_disp[0]==0) {
           o->state= 2;
           goto read_more;
         } else if (o->content_disp[1]=='\r' && o->content_disp[1]=='\n' ) {
           o->state= 2;
           goto read_more;
         } else {
           Sregex_string(&(o->content_disp),NULL,0);
         }
       }
   }
   if(o->state==2) {
     /* read field value */;
     ret= Httprequest_is_boundary(req,rpt,rptlen,read_pt,&false_len,0);
     if(ret<0)
       goto ex;
     if(ret==0 && false_len>0) {
       Httprequest_get_boundary(req,&boundary,0);
       if(Sregex_string_cut(&(o->content),boundary,false_len-1,1)<=0)
         {ret= -1; goto ex;}
     }
     if(ret==0) { 
       rptlen-= *read_pt-rpt;
       rpt= *read_pt;
       if(Sregex_concat_bin(&(o->content),&(o->content_len),rpt,rptlen,0)<=0)
         {ret= -1; goto ex;}
       *read_pt= data+datalen;
       ret= 1; goto ex;
     } else if(ret>0) {
       o->state= -1;
       ret= 1; goto ex;
     }
   }
read_more:;
   rptlen-= (*read_pt-rpt);
   rpt= *read_pt;
   goto read_text;
 }
 *read_pt= data+datalen;
 if(Sregex_string_cut(&(o->content_disp),rpt,rptlen,1)<=0)
   {ret= -1; goto ex;}

 ret= 1;
ex:;
 return(ret);
}


