
/*
  cc -g -o httprequest.c
*/

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

#include "../s_tools/smem.h"
#include "../s_tools/sfile.h"
#include "../s_tools/sregex.h"

#include "httprequest.h"


/* --------------------------  HttprequesT  ----------------------- */


int Httprequest_new(objpt,flag)
struct HttprequesT **objpt;
int flag;
{
 struct HttprequesT *o;
 int ret,i;

 *objpt= o= TSOB_FELD(struct HttprequesT,1);
 if(o==NULL)
   return(-1);

 /* strcpy(o->type_tag,"HttprequesT"); */

 o->state= 0;
 o->method= NULL;
 o->uri= NULL;
 o->http_version= NULL;
 o->content_type= NULL;
 o->boundary= NULL;
 o->boundary_cursor= o->boundary;
 o->headers= NULL;
 o->last_header= NULL;
 o->forms= NULL;
 o->last_form= NULL;
 o->images= NULL;
 o->last_image= NULL;
 o->filter= NULL;
 o->prev= NULL;
 o->next= NULL;

 return(1);
failed:;
 Httprequest_destroy(objpt,0);
 return(-1);
}


int Httprequest_new_headers(o,flag)
struct HttprequesT *o;
int flag;
{
 int ret;
 struct HttpheadeR *c= NULL;

 ret= Httpheader_new(&c,0);
 if(ret<=0)
   return(ret);
 Httpheader_link(c,o->last_header,0);
 o->last_header= c;
 if(o->headers==NULL)
   o->headers= c;
 return(1);
}


int Httprequest_new_forms(o,flag)
struct HttprequesT *o;
int flag;
{
 int ret;
 struct HttpforM *c= NULL;

 ret= Httpform_new(&c,0);
 if(ret<=0)
   return(ret);
 Httpform_link(c,o->last_form,0);
 o->last_form= c;
 if(o->forms==NULL)
   o->forms= c;
 return(1);
}


int Httprequest_new_images(o,flag)
struct HttprequesT *o;
int flag;
{
 int ret;
 struct HttpimagE *c= NULL;

 ret= Httpimage_new(&c,0);
 if(ret<=0)
   return(ret);
 Httpimage_link(c,o->last_image,0);
 o->last_image= c;
 if(o->images==NULL)
   o->images= c;
 return(1);
}


int Httprequest_destroy(objpt,flag)
struct HttprequesT **objpt;
int flag;
{
 struct HttprequesT *o;

 o= *objpt;
 if(o==NULL)
   return(0);

 Sregex_string(&(o->method),NULL,0);
 Sregex_string(&(o->uri),NULL,0);
 Sregex_string(&(o->http_version),NULL,0);
 Sregex_string(&(o->content_type),NULL,0);
 Sregex_string(&(o->boundary),NULL,0);
 Httpheader_destroy_all(&(o->headers),0);
 Httpform_destroy_all(&(o->forms),0);
 Httpimage_destroy_all(&(o->images),0);
 if(o->prev!=NULL)
   o->prev->next= o->next;
 if(o->next!=NULL)
   o->next->prev= o->prev;

 Smem_freE((char *) o);
 *objpt= NULL;
 return(1);
}


int Httprequest_destroy_all(objpt,flag)
struct HttprequesT **objpt;
int flag;
{
 struct HttprequesT *o,*n;

 o= *objpt;
 if(o==NULL)
   return(0);
 for(;o->prev!=NULL;o= o->prev);
 for(;o!=NULL;o= n) {
   n= o->next;
   Httprequest_destroy(&o,0);
 }
 *objpt= NULL;
 return(1);
}


int Httprequest_get_method(o,pt,flag)
struct HttprequesT *o;
char **pt;
int flag;
{
 *pt= o->method;
 return(1);
}


int Httprequest_get_uri(o,pt,flag)
struct HttprequesT *o;
char **pt;
int flag;
{
 *pt= o->uri;
 return(1);
}


int Httprequest_get_http_version(o,pt,flag)
struct HttprequesT *o;
char **pt;
int flag;
{
 *pt= o->http_version;
 return(1);
}


int Httprequest_get_headers(o,pt,flag)
struct HttprequesT *o;
struct HttpheadeR **pt;
int flag;
{
 *pt= o->headers;
 return(1);
}


int Httprequest_get_last_header(o,pt,flag)
struct HttprequesT *o;
struct HttpheadeR **pt;
int flag;
{
 *pt= o->last_header;
 return(1);
}


int Httprequest_get_forms(o,pt,flag)
struct HttprequesT *o;
struct HttpforM **pt;
int flag;
{
 *pt= o->forms;
 return(1);
}


int Httprequest_get_last_form(o,pt,flag)
struct HttprequesT *o;
struct HttpforM **pt;
int flag;
{
 *pt= o->last_form;
 return(1);
}


int Httprequest_get_images(o,pt,flag)
struct HttprequesT *o;
struct HttpimagE **pt;
int flag;
{
 *pt= o->images;
 return(1);
}


int Httprequest_get_last_image(o,pt,flag)
struct HttprequesT *o;
struct HttpimagE **pt;
int flag;
{
 *pt= o->last_image;
 return(1);
}


int Httprequest_get_filter(o,pt,flag)
struct HttprequesT *o;
struct HttpfilteR **pt;
int flag;
{
 *pt= o->filter;
 return(1);
}


int Httprequest_get_prev(o,pt,flag)
struct HttprequesT *o;
struct HttprequesT **pt;
int flag;
{
 *pt= o->prev;
 return(1);
}


int Httprequest_get_next(o,pt,flag)
struct HttprequesT *o;
struct HttprequesT **pt;
int flag;
{
 *pt= o->next;
 return(1);
}


int Httprequest_get_boundary(o,pt,flag)
struct HttprequesT *o;
char **pt;                         /* must point to NULL or freeable memory */
int flag;
{
 *pt= o->boundary;
 return(1);
}


int Httprequest_link(o,link,flag)
struct HttprequesT *o;
struct HttprequesT *link;
int flag;
/*
  bit0= insert as link->prev rather than as link->next
*/
{
 if(o->prev!=NULL)
   o->prev->next= o->next;
 if(o->next!=NULL)
   o->next->prev= o->prev;
 o->prev= o->next= NULL;
 if(link==NULL)
   return(1);
 if(flag&1) {
   o->next= link;
   o->prev= link->prev;
   if(o->prev!=NULL)
     o->prev->next= o;
   link->prev= o;
 } else {
   o->prev= link;
   o->next= link->next;
   if(o->next!=NULL)
     o->next->prev= o;
   link->next= o;
 }
 return(1);
}


int Httprequest_first_line(req,line,flag)
struct HttprequesT *req;
char *line;
int *flag;
{
 int ret;
 char *spt,*ept;

 if(req->state!=0)
   return(0);

 /*   Request-Line   = Method SP Request-URI SP HTTP-Version CRLF    */
 spt= line;
 ept= strchr(spt,' ');
 if(Sregex_string_cut(&(req->method),spt,ept-spt,0)<=0)
   return(-1);
 spt= ept+1;
 ept= strchr(spt,' ');
 if(Sregex_string_cut(&(req->uri),spt,ept-spt,0)<=0)
   return(-1);
 spt= ept+1;
 if(Sregex_string(&(req->http_version),spt,0)<=0)
   return(-1);
 req->state= 1;
 return(1);
}


int Httprequest_split_uri(req,hostname,portnumber,path,flag)
struct HttprequesT *req;
char **hostname;
int *portnumber;
char **path;
int *flag;
{
 int ret;
 char *spt,*ept,*path_pt,*colon_pt;
 
 /*
         Request-URI    = "*" | absoluteURI | abs_path 
         http_URL       = "http:" "//" host [ ":" port ] [ abs_path ]
 */
 Sregex_string(hostname,NULL,0);
 *portnumber= 80;
 Sregex_string(path,NULL,0);
 if(req->uri==NULL)
   {ret= 0; goto ex;}
 if(strncmp(req->uri,"http://",5)==0) {
   spt= req->uri+7;
   colon_pt= strchr(spt,':');
   path_pt= strchr(spt,'/');
   if(colon_pt!=NULL && (path_pt==NULL || colon_pt+1<path_pt)) {
     if(colon_pt>spt+1)
       if(Sregex_string_cut(hostname,spt,colon_pt-spt,0)<=0)
         {ret= -1; goto ex;}
     sscanf(colon_pt,"%ld",portnumber);
   } else if(path_pt!=NULL) {
     if(path_pt>spt+1)
       if(Sregex_string_cut(hostname,spt,path_pt-spt,0)<=0)
         {ret= -1; goto ex;}
   } else {
     if(Sregex_string(hostname,spt,0)<=0)
       {ret= -1; goto ex;}
   }
   if(path_pt!=NULL)
     if(Sregex_string(path,path_pt,0)<=0)
       {ret= -1; goto ex;}
 } else if(req->uri[0]=='/') {
   if(Sregex_string(path,req->uri,0)<=0)
     {ret= -1; goto ex;}
 }
 ret= 1;
ex:;
 return(ret);
}


int Httprequest_is_boundary(req,data,datalen,read_pt,false_len,flag)
struct HttprequesT *req;
char *data;
int datalen;
char **read_pt;
int *false_len;
int flag;
{
 int ret;
 char *cpt,*dpt,*datapt;

 *read_pt= data;
 if(req->boundary_cursor>req->boundary)
   *false_len= req->boundary_cursor - req->boundary;

 for(datapt= data; datapt-data<datalen; datapt++) {
   dpt= datapt;
   for(cpt= req->boundary_cursor;cpt++;*cpt!=0 && dpt-data<datalen)
     if(*(dpt++)!=*cpt) {
       req->boundary_cursor= req->boundary;
   break;
     }
   if(*cpt==0) {
     *read_pt= dpt;
     ret=1; goto ex;
   }
 }
 ret= 0;
ex:;
 return(ret);
}

  
int Httprequest_read_body(req,data,datalen,read_pt,flag)
struct HttprequesT *req;
char *data;
int datalen;
char **read_pt;
int flag;
/*
 bit0= do not look for boundary
*/
{
 int i,l,rptlen,ret,false_len;
 char *rpt,*lfpt,*headerline=NULL,*sempt;

 rpt= data;
 rptlen= datalen;
read_further:;
 if(req->state==2) {
   ret=Httpheader_find_head(req->headers,"Content-Type: ",&headerline,0);
   if(ret<=0) {
set_state_4:;
     req->state= 4;
     goto ex;
   }
   sempt= strchr(headerline,';');
   if(sempt==NULL) 
     goto set_state_4;
   *sempt= 0;
   if(Sregex_string(&(req->content_type),headerline,0)<=0)
     {ret= -1; goto ex;}
   if(Sregex_string(&(req->boundary),sempt+1,0)<=0)
     {ret= -1; goto ex;}
   req->state= 3;
   if(strcmp(req->content_type,"multipart/form-data")==0) {
     ret= Httprequest_new_forms(req,0);
     if(ret<=0)
       goto ex;
   }
 }
 if(!(flag&1)) {
   ret= Httprequest_is_boundary(req,rpt,rptlen,read_pt,&false_len,0);
   if(ret<0)
     goto ex;
   rptlen-= *read_pt-rpt;
   rpt= *read_pt;
   if(ret==0 && false_len>0) {
     ret= Httprequest_read_body(req,req->boundary,false_len,read_pt,1);
     if(ret<=0)
       goto ex;
   } else if(ret>0) {
     if(strcmp(req->content_type,"multipart/form-data")==0) {
       ret= Httpform_new_fields(req->last_form,0);
       if(ret<=0)
         goto ex;
     }
   }
 }
 
 ret= Httpform_read_mpfield(req->last_form,req->boundary,rpt,rptlen,read_pt,0);
 if(ret<0)
   goto ex;
 rptlen-= *read_pt-rpt;
 rpt= *read_pt;
 if(rptlen>0)
   goto read_further;

 ret=1;
ex:;
 Sregex_string(&headerline,NULL,0);
 return(ret);
}


int Httprequest_parse(req,data,datalen,flag)
struct HttprequesT *req;
char *data;
int datalen;
int *flag;
{
 int ret,rptlen;
 char *rpt,*cpt,*read_pt;
 struct HttpheadeR *hdr;

 rpt= data;
 rptlen= datalen;

read_data:;
 if(req->state!=1&&req->state!=2)
   {ret= 0; goto ex;}
 if(rptlen<=0)
   {ret= 2; goto ex;}
 if(req->state==1) {
   /* read as header data */;
   if(req->last_header==NULL) {
     ret= Httprequest_new_headers(req,0);
     if(ret<=0)
       goto ex;
   }  
   if(Httpheader_is_complete(req->last_header,0)) {
     ret= Httprequest_new_headers(req,0);
     if(ret<=0)
       goto ex;
   } 

   /* read up to next CRLF */
   ret= Httpheader_consume(req->last_header,rpt,rptlen,&read_pt,0);
   if(ret<=0)
     goto ex;
   if(Httpheader_is_complete(req->last_header,0)) {
     Httpheader_get_line(req->last_header,&cpt,0);
     if(strlen(cpt)==0) {
       hdr= req->last_header;
       Httpheader_get_prev(req->last_header,&(req->last_header),0);
       if(req->last_header==NULL)
         req->headers= NULL;
       Httpheader_destroy(&hdr,0);
       req->state= 2;
     }
     rptlen-= read_pt-rpt;
     rpt= read_pt;
     goto read_data;
   }
 } 
 if(req->state==2) {
   ret= Httprequest_read_body(req,rpt,rptlen,&read_pt,0);
   if(ret<=0)
     goto ex;
 }
 if(req->state==3) {
   /* just discarding data */;
 }
 ret= 1;
ex:;
 return(ret);
}

 
