
/*
 cc -g -c simv.c
*/

#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <signal.h>


#include "../as/asagent.h"

#include "imvapp.h"

struct ImvapP *app= NULL;



void Cleanup_handler_pipe()
{
 return;
}


void Cleanup_handler_exit()
{
 alarm(0);
 if(app!=NULL) {
   if(!app->agent->silent_end)
     Asagent_stderr(app->agent,"\n\nTIMEOUT ! Program aborted\n\n",1);
   Asagent_destroy(&(app->agent),0);
 }
 exit(4);
}


main(argc,argv)
int argc;
char **argv;
{
 int ret,ard= 1,no_rc= 0,help_only= 0;

 /* <<< preliminary signal handling */
 signal(SIGPIPE,Cleanup_handler_pipe);
 signal(SIGALRM,Cleanup_handler_exit);


 /* full memory supervision */
 Smem_set_record_items(1);

 if(argc==2)
   if(strcmp(argv[1],"-help")==0)
     help_only= 1;
 if(argc>=2)
   if(strcmp(argv[1],"-no_rc")==0)
     no_rc= 1;

 ret= Imvapp_new(&app,argv[0],0);
 if(ret<=0) {
   fprintf(stderr,"%s : creation of application object failed\n",argv[0]);
   exit(1);
 }
 /* memory usage messages each 0(=disabled) commands */
 app->agent->smem_stderr= 0;

 if(!(help_only||no_rc)){
   ret= Imvapp_rc(app,0);
   if(ret<0) {
     ret= 5; goto ex;
   } else if(ret==3)
     goto ok;
 }

 ard= 1+no_rc;
 ret= Imvapp_read_options(app,argc,argv,&ard,0);
 if(ret<=0) {
   ret= 2; goto ex;
 } else if(ret==3 || help_only)
   goto ok;

 ret= Imvapp_loop(app,1);
 if(ret<=0) {
   fprintf(stderr,"%s : event loop aborted\n",argv[0]);
   ret= 3;
   goto ex;
 }
 if(ret==3)
   goto ok;

ok:;
 ret= 0;
ex:
 Imvapp_destroy(&app,0);
 Smem_stderr(1|2);
 exit(ret);
}


