
/*
  cc -g -o snntpbatch snntpbatch.o nntpclient.o nntpgroup.o nntpload.o nntpfilter.o nntphead.o nntpconn.o sregex.o
*/

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <signal.h>

#include "nntpconn.h"
#include "nntpclient.h"


void Cleanup_handler_pipe()
{
 return;
}


main(argc,argv)
int argc;
char **argv;
{
 int i,ret,reading_rc;
 struct NntpclienT *client;
 char *cpt;
 static int rc_flags[3]= {1,4,2};

 signal(SIGPIPE,Cleanup_handler_pipe);

 ret= Nntpclient_new(&client,"",1); /* no connection to server yet */
 if(ret<=0)
   goto err_ex;
 Nntpclient_set_timeout(client,240,0);

 for(reading_rc= 1;reading_rc<=3;reading_rc++) {
   ret= Nntpclient_rc(client,argv[0],rc_flags[reading_rc-1]); 
   if(ret<=0) 
     goto err_ex;
 }
 reading_rc= 0;

 i= 1;
 while(i<argc){
   /* is able to reconnect after timeouts */
   ret= Nntpclient_outer_fence(client,argc,argv,&i,0); 
   if(ret<=0)
     goto err_ex;
   while(++i<argc)
    if(argv[i][0]=='-')
      break;
 }
 exit(0);

err_ex:;
 if(reading_rc){
   cpt= strrchr(argv[0],'/');
   if(cpt==NULL)
     cpt= argv[0];
   else
     cpt++;
   fprintf(stderr,"++++++++++++++++++++++++++++++++++++++++++\n");
   fprintf(stderr,"+++ while reading  ");
   if(reading_rc==1)
     fprintf(stderr,"$HOME/");
   else if(reading_rc==2) 
     fprintf(stderr,"../");
   else if(reading_rc==3) 
     ;
   fprintf(stderr,".%src  :\n",cpt);
 }
 fprintf(stderr,"++++++++++++++++++++++++++++++++++++++++++\n");
 if(client!=NULL)
   if(client->conn!=0){
     fprintf(stderr,"error code = %ld\n",client->conn->errn);
     fprintf(stderr,"%s\n",client->conn->errmsg);
   }
 fprintf(stderr,"+++++++++ premature end of program +++++++\n");
 if(!reading_rc){
   fprintf(stderr,"%ld unprocessed arguments: \n",argc-i);
   for(;i<argc;i++){
     fprintf(stderr,"%s ",argv[i]);
   }
 }
 fprintf(stderr,"\n");
 exit(1);
}

