
/*
 cc -g -c sdb_odbc_stq.c
 link with :  libclntsh
*/


#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <string.h>
#include <errno.h>
#include <math.h>


#include "../s_tools/smem.h"
#include "../s_tools/sfile.h"
#include "../s_tools/sregex.h"


#include "sdb_odbc.h"


#include "sdb_odbc_stq.h"

static char trace_linE[1024];
 

/* ---------------------- SDB wrapper for SQLHSTMT -------------------- */


int Sdb_odbc_stq_new(stq,boss,stmt_text,stmt_length,flag)
struct Sdb_odbc_stQ **stq;
struct Sdb_odbC *boss;
char *stmt_text;
int stmt_length;
int flag;
{
 struct Sdb_odbc_stQ *m;
 int ret;

 m= *stq= TSOB_FELD(struct Sdb_odbc_stQ,1);
 if(m==NULL) {
   ret= -1; goto ex;
 }

 m->boss= boss;
 m->stmt_text= NULL;
 m->stmt_length= 0;
 m->stmt_type= 0;
 m->row_size;
 m->row_offsets= NULL;
 m->row_types= NULL;
 m->row_rlengths= NULL;
 m->row_rcodeps= NULL;
 m->field_adr= NULL;
 m->field_len= NULL;
 m->column_count= 0;
 m->row_buffer= NULL;
 m->receive_buffer= NULL;
 m->receive_cursor= NULL;
 m->result_buffered= 0;

 if(stmt_length<=0)
   goto failed;
 m->stmt_text= Smem_malloC(stmt_length+1);
 if(m->stmt_text==NULL)
   goto failed;
 memcpy(m->stmt_text,stmt_text,stmt_length);
 m->stmt_text[stmt_length]= 0;
 m->stmt_length= stmt_length;

 ret= 1; goto ex;

failed:;
 Sdb_odbc_stq_destroy(stq,0);
 ret= -1;

ex:;
 return(ret);
}


int Sdb_odbc_stq_free_result(stq,flag)
struct Sdb_odbc_stQ *stq;
int flag;
{
 if(stq->row_types!=NULL)
   Smem_free((char *) stq->row_types);
 stq->row_types= NULL;
 if(stq->row_offsets!=NULL)
   Smem_free((char *) stq->row_offsets);
 stq->row_offsets= NULL;
 if(stq->row_rlengths!=NULL)
   Smem_free(stq->row_rlengths);
 stq->row_rlengths= NULL;
 if(stq->row_rcodeps!=NULL)
   Smem_free(stq->row_rcodeps);
 stq->row_rcodeps= NULL;
 if(stq->field_adr!=NULL)
   Smem_free((char *) stq->field_adr);
 stq->field_adr= NULL;
 if(stq->field_len!=NULL)
   Smem_free((char *) stq->field_len);
 stq->field_len= NULL;
 if(stq->row_buffer!=NULL)
   Smem_free((char *) stq->row_buffer);
 stq->row_buffer= NULL;
 return(1);
}


int Sdb_odbc_stq_destroy(stq,flag)
struct Sdb_odbc_stQ **stq;
int flag;
{
 struct Sdb_odbc_stQ *m;
 struct Sdb_odbC *sdb;

/*
 fprintf(stderr,"Sdb_odbc_stq_destroy 1\n");
 fflush(stderr);
*/
 m= *stq;
 if(m==NULL)
   return(0);

 Sdb_odbc_trace(m->boss,"Sdb_odbc_stq_destroy 2",0);

 sdb= m->boss;

 Sdb_odbc_trace(m->boss,"s11 vor : SQLCloseCursor()",0);
 sdb->oret= SQLCloseCursor(m->stmt);
 Sdb_odbc_trace(m->boss,"s11 nach: SQLCloseCursor()",0);
 if(sdb->oret == SQL_SUCCESS_WITH_INFO) {
   Sdb_odbc_checkerr(sdb,sdb->oret,sdb->message,0);
   sdb->oret= SQL_SUCCESS;
 }
 if(sdb->oret != SQL_SUCCESS) {
   Sdb_odbc_checkerr(sdb,sdb->oret,sdb->message,0);
 }
 Sdb_odbc_trace(m->boss,"s12 vor : SQLFreeHandle()",0);
 sdb->oret= SQLFreeHandle(SQL_HANDLE_STMT,m->stmt);
 Sdb_odbc_trace(m->boss,"s12 nach: SQLFreeHandle()",0);
 if(sdb->oret != SQL_SUCCESS) 
   Sdb_odbc_checkerr(sdb,sdb->oret,sdb->message,0);

 Sdb_odbc_trace(m->boss,"Sdb_odbc_stq_destroy 3",0);

 if(m->stmt_text!=NULL)
   Smem_free(m->stmt_text);

 Sdb_odbc_trace(m->boss,"Sdb_odbc_stq_destroy 4",0);

 Sdb_odbc_stq_free_result(m,0);

 Sdb_odbc_trace(m->boss,"Sdb_odbc_stq_destroy 5",0);

 sprintf(trace_linE,"Sdb_odbc_stq_destroy  :  receive_buffer= %X",
                             m->receive_buffer);
 Sdb_odbc_trace(m->boss,trace_linE,0);

 Sdb_odbc_trace(m->boss,"Sdb_odbc_stq_destroy 5.5",0);

 Lstring_destroy_all(&(m->receive_buffer),0);

 Sdb_odbc_trace(m->boss,"Sdb_odbc_stq_destroy 5.7",0);

 Smem_freE((char *) m);

/*
 fprintf(stderr,"Sdb_odbc_stq_destroy 6\n");
*/

 *stq= NULL;
/*
 fprintf(stderr,"Sdb_odbc_stq_destroy return(1)\n");
*/
 return(1);
}


int Sdb_odbc_stq_prepare(stq,flag)
struct Sdb_odbc_stQ *stq;
int flag;
{
 char *dummy;
 int ret;
 struct Sdb_odbC *sdb;

 sdb= stq->boss;

 Sdb_odbc_trace(stq->boss,"s13 vor : SQLAllocHandle()",0);
 sdb->oret= SQLAllocHandle(SQL_HANDLE_STMT,sdb->svchp,&(stq->stmt));
 Sdb_odbc_trace(stq->boss,"s13 nach: SQLAllocHandle()",0);
 if(sdb->oret != SQL_SUCCESS) {
   ret= Sdb_odbc_checkerr(sdb,sdb->oret,sdb->message,0);
   if(ret<=1)
     return(0);
 } 
 sprintf(trace_linE,"s14 stmt :  l= %ld  , t= >%s<",
                    stq->stmt_length,stq->stmt_text);
 Sdb_odbc_trace(stq->boss,trace_linE,0);
 Sdb_odbc_trace(stq->boss,"s14 vor : SQLPrepare()",0);
 sdb->oret= SQLPrepare(stq->stmt,stq->stmt_text,stq->stmt_length);
 Sdb_odbc_trace(stq->boss,"s14 nach: SQLPrepare()",0);
 if(sdb->oret != SQL_SUCCESS) {
   ret= Sdb_odbc_checkerr(sdb,sdb->oret,sdb->message,0);
   if(ret<=1)
     return(0);
 }

 stq->stmt_type= Sdb_odbc_stq_is_unknowN;
 if(stq->stmt_length<7) {
   if(strncmp(stq->stmt_text,"SELECT",6)==0 ||
      strncmp(stq->stmt_text,"select",6)==0)
     stq->stmt_type= Sdb_odbc_stq_is_selecT;
   if(strncmp(stq->stmt_text,"INSERT",6)==0 ||
      strncmp(stq->stmt_text,"insert_text",6)==0)
     stq->stmt_type= Sdb_odbc_stq_is_inserT;
   if(strncmp(stq->stmt_text,"UPDATE",6)==0 ||
      strncmp(stq->stmt_text,"update",6)==0)
     stq->stmt_type= Sdb_odbc_stq_is_updatE;
   if(strncmp(stq->stmt_text,"DELETE",6)==0 ||
      strncmp(stq->stmt_text,"delete",6)==0)
     stq->stmt_type= Sdb_odbc_stq_is_deletE;
 }

 Sdb_odbc_trace(stq->boss,"Sdb_odbc_stq_prepare return(1)",0);
 return(1);
}


int Sdb_odbc_stq_execute(stq,flag)
struct Sdb_odbc_stQ *stq;
int flag;
{
 struct Sdb_odbC *sdb;
 int ret;

 sdb= stq->boss;
 Sdb_odbc_trace(stq->boss,"s15 vor : SQLExecute()",0);
 sdb->oret= SQLExecute(stq->stmt);
 Sdb_odbc_trace(stq->boss,"s15 nach: SQLExecute()",0);
 if(sdb->oret != SQL_SUCCESS) {
   ret= Sdb_odbc_checkerr(sdb,sdb->oret,sdb->message,0);
   if(ret<=1)
     return(0);
 }
 Sdb_odbc_trace(stq->boss,"Sdb_odbc_stq_execute return(1)",0);
 return(1);
}


int Sdb_odbc_stq_is_commitable(stq,flag)
struct Sdb_odbc_stQ *stq;
int flag;
{
 struct Sdb_odbC *sdb;

 sdb= stq->boss;
 if(stq->stmt_type==Sdb_odbc_stq_is_updatE ||
    stq->stmt_type==Sdb_odbc_stq_is_inserT ||
    stq->stmt_type==Sdb_odbc_stq_is_deletE)
   return(1);
 return(0);
}


int Sdb_odbc_stq_rowform(stq,flag)
struct Sdb_odbc_stQ *stq;
int flag;
{
 int ret,i;
 unsigned long rowsize= 0,row_offsets[256],colcount= 0;
 SQLSMALLINT dtypes[256];
 SQLUINTEGER dsize;
 struct Sdb_odbC *sdb;
 char colname_buf[1024];
 SQLSMALLINT colname_len,ddigits,is_nullable;

 sdb= stq->boss;

 /* compute pointer offsets and total rowsize */
 sdb->oret= SQL_SUCCESS;
 row_offsets[0]= 0;
 for(i= 0;i<sizeof(row_offsets)/sizeof(int);i++) {

   Sdb_odbc_trace(stq->boss,"s16 vor : SQLDescribeCol()",0);

   sdb->oret= SQLDescribeCol(stq->stmt,(SQLSMALLINT) (i+1),
                             colname_buf,sizeof(colname_buf),&colname_len,
                             &(dtypes[i]),&dsize,&ddigits,&is_nullable);

   Sdb_odbc_trace(stq->boss,"s16 nach: SQLDescribeCol()",0);

   if(sdb->oret!=SQL_SUCCESS) {
     ret= Sdb_odbc_checkerr(sdb,sdb->oret,sdb->message,0);
     if(ret<=1)
 break;   
   }
   rowsize+= dsize;
   rowsize+= 4-(rowsize%4);
   row_offsets[i+1]= rowsize;
   colcount= i+1;
   sprintf(trace_linE,
           "s16 result :  dsize= %ld  , rowsize= %ld  , colcount= %ld",
           dsize,rowsize,colcount);
   Sdb_odbc_trace(stq->boss,trace_linE,0);
 }

 /* attach row description and define receiving memory */;
 Sdb_odbc_stq_free_result(stq,0);
 stq->row_size= rowsize;
 stq->column_count= 0;
 if(colcount<=0) 
   return(1);

 stq->row_offsets= TSOB_FELD(unsigned long,colcount+1);
 if(stq->row_offsets==NULL) {
no_mem:;
   sprintf(sdb->message,"Not enough memory to receive %ld columns.",
                        colcount);
   return(-1);
 }
 stq->row_types= TSOB_FELD(SQLSMALLINT,colcount);
 if(stq->row_types==NULL)
   goto no_mem;
 stq->row_rlengths= TSOB_FELD(SQLINTEGER,colcount);
 if(stq->row_rlengths==NULL)
   goto no_mem;
 stq->row_rcodeps= TSOB_FELD(ub2,colcount);
 if(stq->row_rcodeps==NULL)
   goto no_mem;
 stq->field_adr= TSOB_FELD(char *,colcount);
 if(stq->field_adr==NULL)
   goto no_mem;
 stq->field_len= TSOB_FELD(unsigned long,colcount);
 if(stq->field_len==NULL)
   goto no_mem;
 stq->row_buffer= TSOB_FELD(char,rowsize);
 if(stq->row_buffer==NULL)
   goto no_mem;
 stq->column_count= colcount;
 stq->row_offsets[0]= 0;
 for(i=0;i<colcount;i++) {
   stq->row_offsets[i+1]= row_offsets[i+1];
   stq->row_types[i]= SQL_C_CHAR;
   stq->field_adr[i]= stq->row_buffer+stq->row_offsets[i];

   /* Define the receiving memory areas */;
   Sdb_odbc_trace(stq->boss,"s17 vor : SQLBindCol()",0);
   sdb->oret= SQLBindCol(stq->stmt,(SQLSMALLINT) (i+1),
                         stq->row_types[i],stq->field_adr[i],
                         stq->row_offsets[i+1]-stq->row_offsets[i],
                         &(stq->row_rlengths[i]));
   Sdb_odbc_trace(stq->boss,"s17 nach: SQLBindCol()",0);
   if(sdb->oret != SQL_SUCCESS) {
     ret= Sdb_odbc_checkerr(sdb,sdb->oret,sdb->message,0);
     if(ret<=1)
       return(0);
   }
   Sdb_odbc_trace(stq->boss,"s17 success : SQLBindCol()",0);
 }
 return(1);
}


int Sdb_odbc_stq_resultbuf(stq,flag)
struct Sdb_odbc_stQ *stq;
int flag;
/*
 bit4= buffer whole reply so query can be left open while intermediate query
*/
{
 int ret,bsize;
 struct Sdb_odbC *sdb;
 struct LstrinG *lpt;
 char *wpt;

 sdb= stq->boss;
 
 bsize= stq->row_size+
        stq->column_count*sizeof(SQLINTEGER)+
        stq->column_count*sizeof(ub2);
 stq->result_buffered= 0;
 if( sdb->fetch_mode==0 || (flag&16) ) {
   /* read all rows into a list buffer */
   Lstring_destroy_all(&(stq->receive_buffer),0);
   lpt= NULL;
   while(1) {
     ret= Sdb_odbc_stq_fetch_row(stq,0);
     if(ret<0)
       return(ret);  
     if(ret==0)
   break;

     sprintf(trace_linE,
             "Sdb_odbc_stq_resultbuf : bsize= %ld",
             bsize);
     Sdb_odbc_trace(stq->boss,trace_linE,0);

     ret= Lstring_new_binary(&(lpt),NULL,bsize,lpt,2);
     if(ret<=0)
       goto no_mem;
     if(stq->receive_buffer==NULL)
       stq->receive_buffer= lpt;
     wpt= lpt->text;
     memcpy(wpt,stq->row_buffer,stq->row_size);
     wpt+= stq->row_size;
     memcpy(wpt,stq->row_rlengths,stq->column_count*sizeof(SQLINTEGER));
     wpt+= stq->column_count*sizeof(SQLINTEGER);
     memcpy(wpt,stq->row_rcodeps,stq->column_count*sizeof(ub2));
     wpt+= stq->column_count*sizeof(ub2);
   }
   stq->result_buffered= 1;
 } 
 stq->receive_cursor= stq->receive_buffer; 
 return(1);

no_mem:;
 sprintf(sdb->message,"Not enough memory to allocate receive buffer.");
 return(-1);
}


int Sdb_odbc_stq_column_count(stq,flag)
struct Sdb_odbc_stQ *stq;
int flag;
{
 return(stq->column_count);
}


int Sdb_odbc_stq_next_row(stq,fields,lengths,flag)
struct Sdb_odbc_stQ *stq;
char ***fields;
unsigned long **lengths;
int flag;
{
 int retry_count= 0,ret,i;
 struct Sdb_odbC *sdb;
 char *rpt;

 sdb= stq->boss;

 if(stq->result_buffered) {
   if(stq->receive_cursor==NULL)
     return(0);
   rpt= stq->receive_cursor->text;
   memcpy(stq->row_buffer,rpt,stq->row_size);
   rpt+= stq->row_size;
   memcpy(stq->row_rlengths,rpt,stq->column_count*sizeof(SQLINTEGER));
   rpt+= stq->column_count*sizeof(SQLINTEGER);
   memcpy(stq->row_rcodeps,rpt,stq->column_count*sizeof(ub2));
   rpt+= stq->column_count*sizeof(ub2);
   stq->receive_cursor= stq->receive_cursor->next;
   for(i=0;i<stq->column_count;i++) 
     stq->field_len[i]= stq->row_rlengths[i];
 } else {
   ret= Sdb_odbc_stq_fetch_row(stq,0);
   if(ret<=0)
     return(ret);
 }
 *fields= stq->field_adr;
 *lengths= stq->field_len;
 return(1);
}


int Sdb_odbc_stq_fetch_row(stq,flag)
struct Sdb_odbc_stQ *stq;
int flag;
{
 struct Sdb_odbC *sdb;
 int i,ret;

 sdb= stq->boss;

 /* fetch row data into row_buffer */
 Sdb_odbc_trace(stq->boss,"s18 vor : SQLFetch()",0);
 sdb->oret= SQLFetch(stq->stmt);
 Sdb_odbc_trace(stq->boss,"s18 nach: SQLFetch()",0);
 if(sdb->oret == SQL_NO_DATA) {
   Sdb_odbc_trace(stq->boss,"s18 result: SQL_NO_DATA",0);
   return(0);
 } else if(sdb->oret != SQL_SUCCESS) {
   ret= Sdb_odbc_checkerr(sdb,sdb->oret,sdb->message,0);
   if(ret<=1) {
     Sdb_odbc_trace(stq->boss,"s18 result: error",0);
     return(-1);
   }
 }
 for(i=0;i<stq->column_count;i++) 
   stq->field_len[i]= stq->row_rlengths[i];

 return(1);
}


int Sdb_odbc_stq_end_query(stq,flag)
struct Sdb_odbc_stQ *stq;
int flag;
{
 int ret;

 if(stq->result_buffered)
   return(2);

 /* ??? is there a fast way to cancel a query ? */

 do {
   ret= Sdb_odbc_stq_fetch_row(stq,0);
 } while(ret>0);
/*
 if(ret<0)
   return(ret);
*/
 return(1);
}


int Sdb_odbc_stq_update_worked(stq,flag)
struct Sdb_odbc_stQ *stq;
int flag;
{
 int ret;
 SQLINTEGER count=0;
 struct Sdb_odbC *sdb;

 sdb= stq->boss;

 /* find out wether the update clause matched at least one row */
 Sdb_odbc_trace(stq->boss,"s19 vor : SQLRowCount()",0);
 sdb->oret= SQLRowCount(stq->stmt,&count); 
 Sdb_odbc_trace(stq->boss,"s19 nach: SQLRowCount()",0);
 if(sdb->oret != SQL_SUCCESS) {
   ret= Sdb_odbc_checkerr(stq->boss,sdb->oret,stq->boss->message,0);
   if(ret<=1)
     return(-1);
 }
 sprintf(trace_linE,"s19 result :  count= %ld",count);
 Sdb_odbc_trace(stq->boss,trace_linE,0);
 ret= (count>0);
 return(ret);
}


